/*
 * @(#)DefaultPixyFactory.java
 *
 * Copyright (C) 1997-2007 Seiichi Yoshida
 * All rights reserved.
 */

package net.aerith.misao.xml;

/**
 * The <code>DefaultPixyFactory</code> is an application side implementation
 * of the class that the relaxer generated automatically.
 *
 * @author  Seiichi Yoshida (comet@aerith.net)
 * @version 2004 November 24
 */

public class DefaultPixyFactory extends net.aerith.misao.xml.relaxer.DefaultPixyFactory {

    /**
     * Creates a default <code>XmlPixy</code>.
     * This method is a hook method of the AbstractPixyFactory.
     *
     * @return XmlPixy
     */
    public net.aerith.misao.xml.relaxer.XmlPixy createXmlPixy() {
        return (new XmlPixy());
    }

    /**
     * Creates a default <code>XmlReport</code>.
     * This method is a hook method of the AbstractPixyFactory.
     *
     * @return XmlReport
     */
    public net.aerith.misao.xml.relaxer.XmlReport createXmlReport() {
        return (new XmlReport());
    }

    /**
     * Creates a default <code>XmlSystem</code>.
     * This method is a hook method of the AbstractPixyFactory.
     *
     * @return XmlSystem
     */
    public net.aerith.misao.xml.relaxer.XmlSystem createXmlSystem() {
        return (new XmlSystem());
    }

    /**
     * Creates a default <code>XmlInformation</code>.
     * This method is a hook method of the AbstractPixyFactory.
     *
     * @return XmlInformation
     */
    public net.aerith.misao.xml.relaxer.XmlInformation createXmlInformation() {
        return (new XmlInformation());
    }

    /**
     * Creates a default <code>XmlImage</code>.
     * This method is a hook method of the AbstractPixyFactory.
     *
     * @return XmlImage
     */
    public net.aerith.misao.xml.relaxer.XmlImage createXmlImage() {
        return (new XmlImage());
    }

    /**
     * Creates a default <code>XmlSize</code>.
     * This method is a hook method of the AbstractPixyFactory.
     *
     * @return XmlSize
     */
    public net.aerith.misao.xml.relaxer.XmlSize createXmlSize() {
        return (new XmlSize());
    }

    /**
     * Creates a default <code>XmlExposure</code>.
     * This method is a hook method of the AbstractPixyFactory.
     *
     * @return XmlExposure
     */
    public net.aerith.misao.xml.relaxer.XmlExposure createXmlExposure() {
        return (new XmlExposure());
    }

    /**
     * Creates a default <code>XmlCenter</code>.
     * This method is a hook method of the AbstractPixyFactory.
     *
     * @return XmlCenter
     */
    public net.aerith.misao.xml.relaxer.XmlCenter createXmlCenter() {
        return (new XmlCenter());
    }

    /**
     * Creates a default <code>XmlFov</code>.
     * This method is a hook method of the AbstractPixyFactory.
     *
     * @return XmlFov
     */
    public net.aerith.misao.xml.relaxer.XmlFov createXmlFov() {
        return (new XmlFov());
    }

    /**
     * Creates a default <code>XmlRotation</code>.
     * This method is a hook method of the AbstractPixyFactory.
     *
     * @return XmlRotation
     */
    public net.aerith.misao.xml.relaxer.XmlRotation createXmlRotation() {
        return (new XmlRotation());
    }

    /**
     * Creates a default <code>XmlPixelSize</code>.
     * This method is a hook method of the AbstractPixyFactory.
     *
     * @return XmlPixelSize
     */
    public net.aerith.misao.xml.relaxer.XmlPixelSize createXmlPixelSize() {
        return (new XmlPixelSize());
    }

    /**
     * Creates a default <code>XmlAstrometricError</code>.
     * This method is a hook method of the AbstractPixyFactory.
     *
     * @return XmlAstrometricError
     */
    public net.aerith.misao.xml.relaxer.XmlAstrometricError createXmlAstrometricError() {
        return (new XmlAstrometricError());
    }

    /**
     * Creates a default <code>XmlDistortionField</code>.
     * This method is a hook method of the AbstractPixyFactory.
     *
     * @return XmlDistortionField
     */
    public net.aerith.misao.xml.relaxer.XmlDistortionField createXmlDistortionField() {
        return (new XmlDistortionField());
    }

    /**
     * Creates a default <code>XmlAstrometry</code>.
     * This method is a hook method of the AbstractPixyFactory.
     *
     * @return XmlAstrometry
     */
    public net.aerith.misao.xml.relaxer.XmlAstrometry createXmlAstrometry() {
        return (new XmlAstrometry());
    }

    /**
     * Creates a default <code>XmlCatalog</code>.
     * This method is a hook method of the AbstractPixyFactory.
     *
     * @return XmlCatalog
     */
    public net.aerith.misao.xml.relaxer.XmlCatalog createXmlCatalog() {
        return (new XmlCatalog());
    }

    /**
     * Creates a default <code>XmlPhotometry</code>.
     * This method is a hook method of the AbstractPixyFactory.
     *
     * @return XmlPhotometry
     */
    public net.aerith.misao.xml.relaxer.XmlPhotometry createXmlPhotometry() {
        return (new XmlPhotometry());
    }

    /**
     * Creates a default <code>XmlReversedImage</code>.
     * This method is a hook method of the AbstractPixyFactory.
     *
     * @return XmlReversedImage
     */
    public net.aerith.misao.xml.relaxer.XmlReversedImage createXmlReversedImage() {
        return (new XmlReversedImage());
    }

    /**
     * Creates a default <code>XmlSbigImage</code>.
     * This method is a hook method of the AbstractPixyFactory.
     *
     * @return XmlSbigImage
     */
    public net.aerith.misao.xml.relaxer.XmlSbigImage createXmlSbigImage() {
        return (new XmlSbigImage());
    }

    /**
     * Creates a default <code>XmlUnofficial</code>.
     * This method is a hook method of the AbstractPixyFactory.
     *
     * @return XmlUnofficial
     */
    public net.aerith.misao.xml.relaxer.XmlUnofficial createXmlUnofficial() {
        return (new XmlUnofficial());
    }

    /**
     * Creates a default <code>XmlStarCount</code>.
     * This method is a hook method of the AbstractPixyFactory.
     *
     * @return XmlStarCount
     */
    public net.aerith.misao.xml.relaxer.XmlStarCount createXmlStarCount() {
        return (new XmlStarCount());
    }

    /**
     * Creates a default <code>XmlData</code>.
     * This method is a hook method of the AbstractPixyFactory.
     *
     * @return XmlData
     */
    public net.aerith.misao.xml.relaxer.XmlData createXmlData() {
        return (new XmlData());
    }

    /**
     * Creates a default <code>XmlStar</code>.
     * This method is a hook method of the AbstractPixyFactory.
     *
     * @return XmlStar
     */
    public net.aerith.misao.xml.relaxer.XmlStar createXmlStar() {
        return (new XmlStar());
    }

    /**
     * Creates a default <code>XmlRecord</code>.
     * This method is a hook method of the AbstractPixyFactory.
     *
     * @return XmlRecord
     */
    public net.aerith.misao.xml.relaxer.XmlRecord createXmlRecord() {
        return (new XmlRecord());
    }

    /**
     * Creates a default <code>XmlCoor</code>.
     * This method is a hook method of the AbstractPixyFactory.
     *
     * @return XmlCoor
     */
    public net.aerith.misao.xml.relaxer.XmlCoor createXmlCoor() {
        return (new XmlCoor());
    }

    /**
     * Creates a default <code>XmlPosition</code>.
     * This method is a hook method of the AbstractPixyFactory.
     *
     * @return XmlPosition
     */
    public net.aerith.misao.xml.relaxer.XmlPosition createXmlPosition() {
        return (new XmlPosition());
    }

    /**
     * Creates a default <code>XmlItem</code>.
     * This method is a hook method of the AbstractPixyFactory.
     *
     * @return XmlItem
     */
    public net.aerith.misao.xml.relaxer.XmlItem createXmlItem() {
        return (new XmlItem());
    }

    /**
     * Creates a default <code>XmlBatch</code>.
     * This method is a hook method of the AbstractPixyFactory.
     *
     * @return XmlBatch
     */
    public net.aerith.misao.xml.relaxer.XmlBatch createXmlBatch() {
        return (new XmlBatch());
    }

    /**
     * Creates a default <code>XmlInstruction</code>.
     * This method is a hook method of the AbstractPixyFactory.
     *
     * @return XmlInstruction
     */
    public net.aerith.misao.xml.relaxer.XmlInstruction createXmlInstruction() {
        return (new XmlInstruction());
    }

    /**
     * Creates a default <code>XmlBaseCatalog</code>.
     * This method is a hook method of the AbstractPixyFactory.
     *
     * @return XmlBaseCatalog
     */
    public net.aerith.misao.xml.relaxer.XmlBaseCatalog createXmlBaseCatalog() {
        return (new XmlBaseCatalog());
    }

    /**
     * Creates a default <code>XmlOutput</code>.
     * This method is a hook method of the AbstractPixyFactory.
     *
     * @return XmlOutput
     */
    public net.aerith.misao.xml.relaxer.XmlOutput createXmlOutput() {
        return (new XmlOutput());
    }

    /**
     * Creates a default <code>XmlInformationHolder</code>.
     * This method is a hook method of the AbstractPixyFactory.
     *
     * @return XmlInformationHolder
     */
    public net.aerith.misao.xml.relaxer.XmlInformationHolder createXmlInformationHolder() {
        return (new XmlInformationHolder());
    }

    /**
     * Creates a default <code>XmlRecordHolder</code>.
     * This method is a hook method of the AbstractPixyFactory.
     *
     * @return XmlRecordHolder
     */
    public net.aerith.misao.xml.relaxer.XmlRecordHolder createXmlRecordHolder() {
        return (new XmlRecordHolder());
    }

    /**
     * Creates a default <code>XmlMagRecordHolder</code>.
     * This method is a hook method of the AbstractPixyFactory.
     *
     * @return XmlMagRecordHolder
     */
    public net.aerith.misao.xml.relaxer.XmlMagRecordHolder createXmlMagRecordHolder() {
        return (new XmlMagRecordHolder());
    }

    /**
     * Creates a default <code>XmlMagRecord</code>.
     * This method is a hook method of the AbstractPixyFactory.
     *
     * @return XmlMagRecord
     */
    public net.aerith.misao.xml.relaxer.XmlMagRecord createXmlMagRecord() {
        return (new XmlMagRecord());
    }

    /**
     * Creates a default <code>XmlMag</code>.
     * This method is a hook method of the AbstractPixyFactory.
     *
     * @return XmlMag
     */
    public net.aerith.misao.xml.relaxer.XmlMag createXmlMag() {
        return (new XmlMag());
    }

    /**
     * Creates a default <code>XmlReported</code>.
     * This method is a hook method of the AbstractPixyFactory.
     *
     * @return XmlReported
     */
    public net.aerith.misao.xml.relaxer.XmlReported createXmlReported() {
        return (new XmlReported());
    }

    /**
     * Creates a default <code>XmlDiscarded</code>.
     * This method is a hook method of the AbstractPixyFactory.
     *
     * @return XmlDiscarded
     */
    public net.aerith.misao.xml.relaxer.XmlDiscarded createXmlDiscarded() {
        return (new XmlDiscarded());
    }

    /**
     * Creates a default <code>XmlPreempted</code>.
     * This method is a hook method of the AbstractPixyFactory.
     *
     * @return XmlPreempted
     */
    public net.aerith.misao.xml.relaxer.XmlPreempted createXmlPreempted() {
        return (new XmlPreempted());
    }

    /**
     * Creates a default <code>XmlImported</code>.
     * This method is a hook method of the AbstractPixyFactory.
     *
     * @return XmlImported
     */
    public net.aerith.misao.xml.relaxer.XmlImported createXmlImported() {
        return (new XmlImported());
    }

    /**
     * Creates a default <code>XmlBlending</code>.
     * This method is a hook method of the AbstractPixyFactory.
     *
     * @return XmlBlending
     */
    public net.aerith.misao.xml.relaxer.XmlBlending createXmlBlending() {
        return (new XmlBlending());
    }

    /**
     * Creates a default <code>XmlPositionRecordHolder</code>.
     * This method is a hook method of the AbstractPixyFactory.
     *
     * @return XmlPositionRecordHolder
     */
    public net.aerith.misao.xml.relaxer.XmlPositionRecordHolder createXmlPositionRecordHolder() {
        return (new XmlPositionRecordHolder());
    }

    /**
     * Creates a default <code>XmlPositionRecord</code>.
     * This method is a hook method of the AbstractPixyFactory.
     *
     * @return XmlPositionRecord
     */
    public net.aerith.misao.xml.relaxer.XmlPositionRecord createXmlPositionRecord() {
        return (new XmlPositionRecord());
    }

    /**
     * Creates a default <code>XmlVariabilityHolder</code>.
     * This method is a hook method of the AbstractPixyFactory.
     *
     * @return XmlVariabilityHolder
     */
    public net.aerith.misao.xml.relaxer.XmlVariabilityHolder createXmlVariabilityHolder() {
        return (new XmlVariabilityHolder());
    }

    /**
     * Creates a default <code>XmlVariability</code>.
     * This method is a hook method of the AbstractPixyFactory.
     *
     * @return XmlVariability
     */
    public net.aerith.misao.xml.relaxer.XmlVariability createXmlVariability() {
        return (new XmlVariability());
    }

    /**
     * Creates a default <code>XmlConfiguration</code>.
     * This method is a hook method of the AbstractPixyFactory.
     *
     * @return XmlConfiguration
     */
    public net.aerith.misao.xml.relaxer.XmlConfiguration createXmlConfiguration() {
        return (new XmlConfiguration());
    }

    /**
     * Creates a default <code>XmlCatalogPath</code>.
     * This method is a hook method of the AbstractPixyFactory.
     *
     * @return XmlCatalogPath
     */
    public net.aerith.misao.xml.relaxer.XmlCatalogPath createXmlCatalogPath() {
        return (new XmlCatalogPath());
    }

    /**
     * Creates a default <code>XmlImageConfig</code>.
     * This method is a hook method of the AbstractPixyFactory.
     *
     * @return XmlImageConfig
     */
    public net.aerith.misao.xml.relaxer.XmlImageConfig createXmlImageConfig() {
        return (new XmlImageConfig());
    }

    /**
     * Creates a default <code>RContext</code>.
     * This method is a hook method of the AbstractPixyFactory.
     *
     * @return RContext
     */
    public net.aerith.misao.xml.relaxer.RContext createRContext() {
        return (new RContext());
    }

    /**
     * Creates an array of <code>XmlBlending</code>.
     *
     * @return XmlBlending[]
     */
    public net.aerith.misao.xml.relaxer.XmlBlending[] createArrayXmlBlending(int size) {
        return new XmlBlending[size];
    }

    /**
     * Creates an array of <code>XmlCatalogPath</code>.
     *
     * @return XmlCatalogPath[]
     */
    public net.aerith.misao.xml.relaxer.XmlCatalogPath[] createArrayXmlCatalogPath(int size) {
        return new XmlCatalogPath[size];
    }

    /**
     * Creates an array of <code>XmlInformation</code>.
     *
     * @return XmlInformation[]
     */
    public net.aerith.misao.xml.relaxer.XmlInformation[] createArrayXmlInformation(int size) {
        return new XmlInformation[size];
    }

    /**
     * Creates an array of <code>XmlInstruction</code>.
     *
     * @return XmlInstruction[]
     */
    public net.aerith.misao.xml.relaxer.XmlInstruction[] createArrayXmlInstruction(int size) {
        return new XmlInstruction[size];
    }

    /**
     * Creates an array of <code>XmlItem</code>.
     *
     * @return XmlItem[]
     */
    public net.aerith.misao.xml.relaxer.XmlItem[] createArrayXmlItem(int size) {
        return new XmlItem[size];
    }

    /**
     * Creates an array of <code>XmlMagRecord</code>.
     *
     * @return XmlMagRecord[]
     */
    public net.aerith.misao.xml.relaxer.XmlMagRecord[] createArrayXmlMagRecord(int size) {
        return new XmlMagRecord[size];
    }

    /**
     * Creates an array of <code>XmlOutput</code>.
     *
     * @return XmlOutput[]
     */
    public net.aerith.misao.xml.relaxer.XmlOutput[] createArrayXmlOutput(int size) {
        return new XmlOutput[size];
    }

    /**
     * Creates an array of <code>XmlPositionRecord</code>.
     *
     * @return XmlPositionRecord[]
     */
    public net.aerith.misao.xml.relaxer.XmlPositionRecord[] createArrayXmlPositionRecord(int size) {
        return new XmlPositionRecord[size];
    }

    /**
     * Creates an array of <code>XmlRecord</code>.
     *
     * @return XmlRecord[]
     */
    public net.aerith.misao.xml.relaxer.XmlRecord[] createArrayXmlRecord(int size) {
        return new XmlRecord[size];
    }

    /**
     * Creates an array of <code>XmlReported</code>.
     *
     * @return XmlReported[]
     */
    public net.aerith.misao.xml.relaxer.XmlReported[] createArrayXmlReported(int size) {
        return new XmlReported[size];
    }

    /**
     * Creates an array of <code>XmlStar</code>.
     *
     * @return XmlStar[]
     */
    public net.aerith.misao.xml.relaxer.XmlStar[] createArrayXmlStar(int size) {
        return new XmlStar[size];
    }

    /**
     * Creates an array of <code>XmlVariability</code>.
     *
     * @return XmlVariability[]
     */
    public net.aerith.misao.xml.relaxer.XmlVariability[] createArrayXmlVariability(int size) {
        return new XmlVariability[size];
    }
}
