package net.aerith.misao.xml.relaxer;

import org.w3c.dom.*;

/**
 * <b>XmlAstrometricError</b> is generated by Relaxer based on pixy.rlx.
 * This class is derived from:
 * 
 * <!-- for programmer
 * <elementRule role="astrometric-error">
 *   <sequence>
 *     <element name="ra" type="float"/>
 *     <element name="decl" type="float"/>
 *   </sequence>
 * </elementRule>
 * 
 * <tag name="astrometric-error">
 *   <attribute name="unit" required="true" type="string"/>
 * </tag>
 * -->
 * <!-- for javadoc -->
 * <pre> &lt;elementRule role="astrometric-error"&gt;
 *   &lt;sequence&gt;
 *     &lt;element name="ra" type="float"/&gt;
 *     &lt;element name="decl" type="float"/&gt;
 *   &lt;/sequence&gt;
 * &lt;/elementRule&gt;
 * &lt;tag name="astrometric-error"&gt;
 *   &lt;attribute name="unit" required="true" type="string"/&gt;
 * &lt;/tag&gt;
 * </pre>
 *
 * @version pixy.rlx (Tue Nov 23 20:34:01 JST 2004)
 * @author  Relaxer 0.10.1 (by ASAMI@Yokohama)
 */
public class XmlAstrometricError extends net.aerith.misao.xml.IONode implements java.io.Serializable, IRNode {
    private String unit;
    private float ra;
    private float decl;
    private IRNode parentRNode;
    private RContext rContext;

    /**
     * Creates a <code>XmlAstrometricError</code>.
     *
     */
    public XmlAstrometricError() {
    }

    /**
     * Creates a <code>XmlAstrometricError</code> by the Stack <code>stack</code>
     * that contains Elements.
     * This constructor is supposed to be used internally
     * by the Relaxer system.
     *
     * @param stack
     */
    public XmlAstrometricError(RStack stack) {
        setup(stack);
    }

    /**
     * Creates a <code>XmlAstrometricError</code> by the Document <code>doc</code>.
     *
     * @param doc
     */
    public XmlAstrometricError(Document doc) {
        setup(doc.getDocumentElement());
    }

    /**
     * Creates a <code>XmlAstrometricError</code> by the Element <code>element</code>.
     *
     * @param element
     */
    public XmlAstrometricError(Element element) {
        setup(element);
    }

    /**
     * Initializes the <code>XmlAstrometricError</code> by the Document <code>doc</code>.
     *
     * @param doc
     */
    public void setup(Document doc) {
        setup(doc.getDocumentElement());
    }

    /**
     * Initializes the <code>XmlAstrometricError</code> by the Element <code>element</code>.
     *
     * @param element
     */
    public void setup(Element element) {
        init(element);
    }

    /**
     * Initializes the <code>XmlAstrometricError</code> by the Stack <code>stack</code>
     * that contains Elements.
     * This constructor is supposed to be used internally
     * by the Relaxer system.
     *
     * @param stack
     */
    public void setup(RStack stack) {
        setup(stack.popElement());
    }

    /**
     * @param element
     */
    private void init(Element element) {
        IPixyFactory factory = PixyFactory.getFactory();
        RStack stack = new RStack(element);
        unit = URelaxer.getAttributePropertyAsString(element, "unit");
        ra = URelaxer.getElementPropertyAsFloat(stack.popElement());
        decl = URelaxer.getElementPropertyAsFloat(stack.popElement());
    }

    /**
     * Creates a DOM representation of the object.
     * Result is appended to the Node <code>parent</code>.
     *
     * @param parent
     */
    public void makeElement(Node parent) {
        Document doc;
        if (parent instanceof Document) {
            doc = (Document)parent;
        } else {
            doc = parent.getOwnerDocument();
        }
        Element element = doc.createElement("astrometric-error");
        int size;
        URelaxer.setAttributePropertyByString(element, "unit", unit);
        URelaxer.setElementPropertyByFloat(element, "ra", ra);
        URelaxer.setElementPropertyByFloat(element, "decl", decl);
        parent.appendChild(element);
    }

    /**
     * Gets the String property <b>unit</b>.
     *
     * @return String
     */
    public final String getUnit() {
        return (unit);
    }

    /**
     * Sets the String property <b>unit</b>.
     *
     * @param unit
     */
    public final void setUnit(String unit) {
        this.unit = unit;
    }

    /**
     * Gets the float property <b>ra</b>.
     *
     * @return float
     */
    public final float getRa() {
        return (ra);
    }

    /**
     * Sets the float property <b>ra</b>.
     *
     * @param ra
     */
    public final void setRa(float ra) {
        this.ra = ra;
    }

    /**
     * Gets the float property <b>decl</b>.
     *
     * @return float
     */
    public final float getDecl() {
        return (decl);
    }

    /**
     * Sets the float property <b>decl</b>.
     *
     * @param decl
     */
    public final void setDecl(float decl) {
        this.decl = decl;
    }

    /**
     * Gets the IRNode property <b>parentRNode</b>.
     *
     * @return IRNode
     */
    public final IRNode getParentRNode() {
        return (parentRNode);
    }

    /**
     * Sets the IRNode property <b>parentRNode</b>.
     *
     * @param parentRNode
     */
    public final void setParentRNode(IRNode parentRNode) {
        this.parentRNode = parentRNode;
    }

    /**
     * Gets child RNodes.
     *
     * @return IRNode[]
     */
    public IRNode[] getRNodes() {
        java.util.List classNodes = new java.util.ArrayList();
        IRNode[] nodes = new IRNode[classNodes.size()];
        return ((IRNode[])classNodes.toArray(nodes));
    }

    /**
     * Gets the RContext property <b>rContext</b>.
     *
     * @return RContext
     */
    public final RContext getRContext() {
        return (rContext);
    }

    /**
     * Sets the RContext property <b>rContext</b>.
     *
     * @param rContext
     */
    public final void setRContext(RContext rContext) {
        this.rContext = rContext;
        IRNode[] contextRNodes = getRNodes();
        for (int i = 0;i < contextRNodes.length;i++) {
            contextRNodes[i].setRContext(rContext);
        }
    }

    /**
     * Gets the property "rContext" which is resolved recursively.
     *
     * @return RContext
     */
    public RContext getRContextResolved() {
        if (rContext != null) {
            return (rContext);
        }
        if (parentRNode == null) {
            return (null);
        }
        return (parentRNode.getRContextResolved());
    }

    /**
     * Tests if a Element <code>element</code> is valid
     * for the <code>XmlAstrometricError</code>.
     *
     * @param element
     * @return boolean
     */
    public static boolean isMatch(Element element) {
        String tagName = element.getTagName();
        if (!"astrometric-error".equals(tagName)) {
            return (false);
        }
        RStack target = new RStack(element);
        Element child;
        child = target.popElement();
        if (child == null) {
            return (false);
        }
        if (!"ra".equals(child.getTagName())) {
            return (false);
        }
        child = target.popElement();
        if (child == null) {
            return (false);
        }
        if (!"decl".equals(child.getTagName())) {
            return (false);
        }
        if (!target.isEmptyElement()) {
            return (false);
        }
        return (true);
    }

    /**
     * Tests if elements contained in a Stack <code>stack</code>
     * is valid for the <code>XmlAstrometricError</code>.
     * This mehtod is supposed to be used internally
     * by the Relaxer system.
     *
     * @param stack
     * @return boolean
     */
    public static boolean isMatch(RStack stack) {
        Element element = stack.peekElement();
        if (element == null) {
            return (false);
        }
        return (isMatch(element));
    }

    /**
     * Tests if elements contained in a Stack <code>stack</code>
     * is valid for the <code>XmlAstrometricError</code>.
     * This method consumes the stack contents during matching operation.
     * This mehtod is supposed to be used internally
     * by the Relaxer system.
     *
     * @param stack
     * @return boolean
     */
    public static boolean isMatchHungry(RStack stack) {
        Element element = stack.peekElement();
        if (element == null) {
            return (false);
        }
        if (isMatch(element)) {
            stack.popElement();
            return (true);
        } else {
            return (false);
        }
    }
}
