package net.aerith.misao.xml.relaxer;

import org.w3c.dom.*;

/**
 * <b>XmlBatch</b> is generated by Relaxer based on pixy.rlx.
 * This class is derived from:
 * 
 * <!-- for programmer
 * <elementRule role="batch">
 *   <ref label="instruction" occurs="*"/>
 * </elementRule>
 * 
 * <tag name="batch"/>
 * -->
 * <!-- for javadoc -->
 * <pre> &lt;elementRule role="batch"&gt;
 *   &lt;ref label="instruction" occurs="*"/&gt;
 * &lt;/elementRule&gt;
 * &lt;tag name="batch"/&gt;
 * </pre>
 *
 * @version pixy.rlx (Tue Nov 23 20:34:01 JST 2004)
 * @author  Relaxer 0.10.1 (by ASAMI@Yokohama)
 */
public class XmlBatch extends net.aerith.misao.xml.IONode implements java.io.Serializable, IRNode {
    // List<XmlInstruction>
    private java.util.List instruction = new java.util.ArrayList();
    private IRNode parentRNode;
    private RContext rContext;

    /**
     * Creates a <code>XmlBatch</code>.
     *
     */
    public XmlBatch() {
    }

    /**
     * Creates a <code>XmlBatch</code> by the Stack <code>stack</code>
     * that contains Elements.
     * This constructor is supposed to be used internally
     * by the Relaxer system.
     *
     * @param stack
     */
    public XmlBatch(RStack stack) {
        setup(stack);
    }

    /**
     * Creates a <code>XmlBatch</code> by the Document <code>doc</code>.
     *
     * @param doc
     */
    public XmlBatch(Document doc) {
        setup(doc.getDocumentElement());
    }

    /**
     * Creates a <code>XmlBatch</code> by the Element <code>element</code>.
     *
     * @param element
     */
    public XmlBatch(Element element) {
        setup(element);
    }

    /**
     * Initializes the <code>XmlBatch</code> by the Document <code>doc</code>.
     *
     * @param doc
     */
    public void setup(Document doc) {
        setup(doc.getDocumentElement());
    }

    /**
     * Initializes the <code>XmlBatch</code> by the Element <code>element</code>.
     *
     * @param element
     */
    public void setup(Element element) {
        init(element);
    }

    /**
     * Initializes the <code>XmlBatch</code> by the Stack <code>stack</code>
     * that contains Elements.
     * This constructor is supposed to be used internally
     * by the Relaxer system.
     *
     * @param stack
     */
    public void setup(RStack stack) {
        setup(stack.popElement());
    }

    /**
     * @param element
     */
    private void init(Element element) {
        IPixyFactory factory = PixyFactory.getFactory();
        RStack stack = new RStack(element);
        instruction.clear();
        while (!stack.isEmptyElement()) {
            if (XmlInstruction.isMatch(stack)) {
                addInstruction(factory.createXmlInstruction(stack));
            } else {
                break;
            }
        }
    }

    /**
     * Creates a DOM representation of the object.
     * Result is appended to the Node <code>parent</code>.
     *
     * @param parent
     */
    public void makeElement(Node parent) {
        Document doc;
        if (parent instanceof Document) {
            doc = (Document)parent;
        } else {
            doc = parent.getOwnerDocument();
        }
        Element element = doc.createElement("batch");
        int size;
        size = instruction.size();
        for (int i = 0;i < size;i++) {
            XmlInstruction value = (XmlInstruction)this.instruction.get(i);
            value.makeElement(element);
        }
        parent.appendChild(element);
    }

    /**
     * Gets the XmlInstruction property <b>instruction</b>.
     *
     * @return XmlInstruction[]
     */
    public final XmlInstruction[] getInstruction() {
        IPixyFactory factory = PixyFactory.getFactory();
        XmlInstruction[] array = factory.createArrayXmlInstruction(instruction.size());
        return ((XmlInstruction[])instruction.toArray(array));
    }

    /**
     * Sets the XmlInstruction property <b>instruction</b>.
     *
     * @param instruction
     */
    public final void setInstruction(XmlInstruction[] instruction) {
        this.instruction.clear();
        this.instruction.addAll(java.util.Arrays.asList(instruction));
        for (int i = 0;i < instruction.length;i++) {
            instruction[i].setParentRNode(this);
        }
    }

    /**
     * Adds the XmlInstruction property <b>instruction</b>.
     *
     * @param instruction
     */
    public final void addInstruction(XmlInstruction instruction) {
        this.instruction.add(instruction);
        instruction.setParentRNode(this);
    }

    /**
     * Gets the IRNode property <b>parentRNode</b>.
     *
     * @return IRNode
     */
    public final IRNode getParentRNode() {
        return (parentRNode);
    }

    /**
     * Sets the IRNode property <b>parentRNode</b>.
     *
     * @param parentRNode
     */
    public final void setParentRNode(IRNode parentRNode) {
        this.parentRNode = parentRNode;
    }

    /**
     * Gets child RNodes.
     *
     * @return IRNode[]
     */
    public IRNode[] getRNodes() {
        java.util.List classNodes = new java.util.ArrayList();
        classNodes.addAll(instruction);
        IRNode[] nodes = new IRNode[classNodes.size()];
        return ((IRNode[])classNodes.toArray(nodes));
    }

    /**
     * Gets the RContext property <b>rContext</b>.
     *
     * @return RContext
     */
    public final RContext getRContext() {
        return (rContext);
    }

    /**
     * Sets the RContext property <b>rContext</b>.
     *
     * @param rContext
     */
    public final void setRContext(RContext rContext) {
        this.rContext = rContext;
        IRNode[] contextRNodes = getRNodes();
        for (int i = 0;i < contextRNodes.length;i++) {
            contextRNodes[i].setRContext(rContext);
        }
    }

    /**
     * Gets the property "rContext" which is resolved recursively.
     *
     * @return RContext
     */
    public RContext getRContextResolved() {
        if (rContext != null) {
            return (rContext);
        }
        if (parentRNode == null) {
            return (null);
        }
        return (parentRNode.getRContextResolved());
    }

    /**
     * Tests if a Element <code>element</code> is valid
     * for the <code>XmlBatch</code>.
     *
     * @param element
     * @return boolean
     */
    public static boolean isMatch(Element element) {
        String tagName = element.getTagName();
        if (!"batch".equals(tagName)) {
            return (false);
        }
        RStack target = new RStack(element);
        Element child;
        while (!target.isEmptyElement()) {
            if (!XmlInstruction.isMatchHungry(target)) {
                break;
            }
        }
        if (!target.isEmptyElement()) {
            return (false);
        }
        return (true);
    }

    /**
     * Tests if elements contained in a Stack <code>stack</code>
     * is valid for the <code>XmlBatch</code>.
     * This mehtod is supposed to be used internally
     * by the Relaxer system.
     *
     * @param stack
     * @return boolean
     */
    public static boolean isMatch(RStack stack) {
        Element element = stack.peekElement();
        if (element == null) {
            return (false);
        }
        return (isMatch(element));
    }

    /**
     * Tests if elements contained in a Stack <code>stack</code>
     * is valid for the <code>XmlBatch</code>.
     * This method consumes the stack contents during matching operation.
     * This mehtod is supposed to be used internally
     * by the Relaxer system.
     *
     * @param stack
     * @return boolean
     */
    public static boolean isMatchHungry(RStack stack) {
        Element element = stack.peekElement();
        if (element == null) {
            return (false);
        }
        if (isMatch(element)) {
            stack.popElement();
            return (true);
        } else {
            return (false);
        }
    }
}
