package net.aerith.misao.xml.relaxer;

import org.w3c.dom.*;

/**
 * <b>XmlData</b> is generated by Relaxer based on pixy.rlx.
 * This class is derived from:
 * 
 * <!-- for programmer
 * <elementRule role="data">
 *   <ref label="star" occurs="*"/>
 * </elementRule>
 * 
 * <tag name="data"/>
 * -->
 * <!-- for javadoc -->
 * <pre> &lt;elementRule role="data"&gt;
 *   &lt;ref label="star" occurs="*"/&gt;
 * &lt;/elementRule&gt;
 * &lt;tag name="data"/&gt;
 * </pre>
 *
 * @version pixy.rlx (Tue Nov 23 20:34:01 JST 2004)
 * @author  Relaxer 0.10.1 (by ASAMI@Yokohama)
 */
public class XmlData extends net.aerith.misao.xml.IONode implements java.io.Serializable, IRNode {
    // List<XmlStar>
    private java.util.List star = new java.util.ArrayList();
    private IRNode parentRNode;
    private RContext rContext;

    /**
     * Creates a <code>XmlData</code>.
     *
     */
    public XmlData() {
    }

    /**
     * Creates a <code>XmlData</code> by the Stack <code>stack</code>
     * that contains Elements.
     * This constructor is supposed to be used internally
     * by the Relaxer system.
     *
     * @param stack
     */
    public XmlData(RStack stack) {
        setup(stack);
    }

    /**
     * Creates a <code>XmlData</code> by the Document <code>doc</code>.
     *
     * @param doc
     */
    public XmlData(Document doc) {
        setup(doc.getDocumentElement());
    }

    /**
     * Creates a <code>XmlData</code> by the Element <code>element</code>.
     *
     * @param element
     */
    public XmlData(Element element) {
        setup(element);
    }

    /**
     * Initializes the <code>XmlData</code> by the Document <code>doc</code>.
     *
     * @param doc
     */
    public void setup(Document doc) {
        setup(doc.getDocumentElement());
    }

    /**
     * Initializes the <code>XmlData</code> by the Element <code>element</code>.
     *
     * @param element
     */
    public void setup(Element element) {
        init(element);
    }

    /**
     * Initializes the <code>XmlData</code> by the Stack <code>stack</code>
     * that contains Elements.
     * This constructor is supposed to be used internally
     * by the Relaxer system.
     *
     * @param stack
     */
    public void setup(RStack stack) {
        setup(stack.popElement());
    }

    /**
     * @param element
     */
    private void init(Element element) {
        IPixyFactory factory = PixyFactory.getFactory();
        RStack stack = new RStack(element);
        star.clear();
        while (!stack.isEmptyElement()) {
            if (XmlStar.isMatch(stack)) {
                addStar(factory.createXmlStar(stack));
            } else {
                break;
            }
        }
    }

    /**
     * Creates a DOM representation of the object.
     * Result is appended to the Node <code>parent</code>.
     *
     * @param parent
     */
    public void makeElement(Node parent) {
        Document doc;
        if (parent instanceof Document) {
            doc = (Document)parent;
        } else {
            doc = parent.getOwnerDocument();
        }
        Element element = doc.createElement("data");
        int size;
        size = star.size();
        for (int i = 0;i < size;i++) {
            XmlStar value = (XmlStar)this.star.get(i);
            value.makeElement(element);
        }
        parent.appendChild(element);
    }

    /**
     * Gets the XmlStar property <b>star</b>.
     *
     * @return XmlStar[]
     */
    public final XmlStar[] getStar() {
        IPixyFactory factory = PixyFactory.getFactory();
        XmlStar[] array = factory.createArrayXmlStar(star.size());
        return ((XmlStar[])star.toArray(array));
    }

    /**
     * Sets the XmlStar property <b>star</b>.
     *
     * @param star
     */
    public final void setStar(XmlStar[] star) {
        this.star.clear();
        this.star.addAll(java.util.Arrays.asList(star));
        for (int i = 0;i < star.length;i++) {
            star[i].setParentRNode(this);
        }
    }

    /**
     * Adds the XmlStar property <b>star</b>.
     *
     * @param star
     */
    public final void addStar(XmlStar star) {
        this.star.add(star);
        star.setParentRNode(this);
    }

    /**
     * Gets the IRNode property <b>parentRNode</b>.
     *
     * @return IRNode
     */
    public final IRNode getParentRNode() {
        return (parentRNode);
    }

    /**
     * Sets the IRNode property <b>parentRNode</b>.
     *
     * @param parentRNode
     */
    public final void setParentRNode(IRNode parentRNode) {
        this.parentRNode = parentRNode;
    }

    /**
     * Gets child RNodes.
     *
     * @return IRNode[]
     */
    public IRNode[] getRNodes() {
        java.util.List classNodes = new java.util.ArrayList();
        classNodes.addAll(star);
        IRNode[] nodes = new IRNode[classNodes.size()];
        return ((IRNode[])classNodes.toArray(nodes));
    }

    /**
     * Gets the RContext property <b>rContext</b>.
     *
     * @return RContext
     */
    public final RContext getRContext() {
        return (rContext);
    }

    /**
     * Sets the RContext property <b>rContext</b>.
     *
     * @param rContext
     */
    public final void setRContext(RContext rContext) {
        this.rContext = rContext;
        IRNode[] contextRNodes = getRNodes();
        for (int i = 0;i < contextRNodes.length;i++) {
            contextRNodes[i].setRContext(rContext);
        }
    }

    /**
     * Gets the property "rContext" which is resolved recursively.
     *
     * @return RContext
     */
    public RContext getRContextResolved() {
        if (rContext != null) {
            return (rContext);
        }
        if (parentRNode == null) {
            return (null);
        }
        return (parentRNode.getRContextResolved());
    }

    /**
     * Tests if a Element <code>element</code> is valid
     * for the <code>XmlData</code>.
     *
     * @param element
     * @return boolean
     */
    public static boolean isMatch(Element element) {
        String tagName = element.getTagName();
        if (!"data".equals(tagName)) {
            return (false);
        }
        RStack target = new RStack(element);
        Element child;
        while (!target.isEmptyElement()) {
            if (!XmlStar.isMatchHungry(target)) {
                break;
            }
        }
        if (!target.isEmptyElement()) {
            return (false);
        }
        return (true);
    }

    /**
     * Tests if elements contained in a Stack <code>stack</code>
     * is valid for the <code>XmlData</code>.
     * This mehtod is supposed to be used internally
     * by the Relaxer system.
     *
     * @param stack
     * @return boolean
     */
    public static boolean isMatch(RStack stack) {
        Element element = stack.peekElement();
        if (element == null) {
            return (false);
        }
        return (isMatch(element));
    }

    /**
     * Tests if elements contained in a Stack <code>stack</code>
     * is valid for the <code>XmlData</code>.
     * This method consumes the stack contents during matching operation.
     * This mehtod is supposed to be used internally
     * by the Relaxer system.
     *
     * @param stack
     * @return boolean
     */
    public static boolean isMatchHungry(RStack stack) {
        Element element = stack.peekElement();
        if (element == null) {
            return (false);
        }
        if (isMatch(element)) {
            stack.popElement();
            return (true);
        } else {
            return (false);
        }
    }
}
