package net.aerith.misao.xml.relaxer;

import org.w3c.dom.*;

/**
 * <b>XmlImageConfig</b> is generated by Relaxer based on pixy.rlx.
 * This class is derived from:
 * 
 * <!-- for programmer
 * <elementRule role="image-config">
 *   <sequence>
 *     <element name="fits-order" occurs="?" type="string"/>
 *   </sequence>
 * </elementRule>
 * 
 * <tag name="image-config"/>
 * -->
 * <!-- for javadoc -->
 * <pre> &lt;elementRule role="image-config"&gt;
 *   &lt;sequence&gt;
 *     &lt;element name="fits-order" occurs="?" type="string"/&gt;
 *   &lt;/sequence&gt;
 * &lt;/elementRule&gt;
 * &lt;tag name="image-config"/&gt;
 * </pre>
 *
 * @version pixy.rlx (Tue Nov 23 20:34:01 JST 2004)
 * @author  Relaxer 0.10.1 (by ASAMI@Yokohama)
 */
public class XmlImageConfig extends net.aerith.misao.xml.IONode implements java.io.Serializable, IRNode {
    private String fitsOrder;
    private IRNode parentRNode;
    private RContext rContext;

    /**
     * Creates a <code>XmlImageConfig</code>.
     *
     */
    public XmlImageConfig() {
    }

    /**
     * Creates a <code>XmlImageConfig</code> by the Stack <code>stack</code>
     * that contains Elements.
     * This constructor is supposed to be used internally
     * by the Relaxer system.
     *
     * @param stack
     */
    public XmlImageConfig(RStack stack) {
        setup(stack);
    }

    /**
     * Creates a <code>XmlImageConfig</code> by the Document <code>doc</code>.
     *
     * @param doc
     */
    public XmlImageConfig(Document doc) {
        setup(doc.getDocumentElement());
    }

    /**
     * Creates a <code>XmlImageConfig</code> by the Element <code>element</code>.
     *
     * @param element
     */
    public XmlImageConfig(Element element) {
        setup(element);
    }

    /**
     * Initializes the <code>XmlImageConfig</code> by the Document <code>doc</code>.
     *
     * @param doc
     */
    public void setup(Document doc) {
        setup(doc.getDocumentElement());
    }

    /**
     * Initializes the <code>XmlImageConfig</code> by the Element <code>element</code>.
     *
     * @param element
     */
    public void setup(Element element) {
        init(element);
    }

    /**
     * Initializes the <code>XmlImageConfig</code> by the Stack <code>stack</code>
     * that contains Elements.
     * This constructor is supposed to be used internally
     * by the Relaxer system.
     *
     * @param stack
     */
    public void setup(RStack stack) {
        setup(stack.popElement());
    }

    /**
     * @param element
     */
    private void init(Element element) {
        IPixyFactory factory = PixyFactory.getFactory();
        RStack stack = new RStack(element);
        fitsOrder = URelaxer.getElementPropertyAsStringByStack(stack, "fits-order");
    }

    /**
     * Creates a DOM representation of the object.
     * Result is appended to the Node <code>parent</code>.
     *
     * @param parent
     */
    public void makeElement(Node parent) {
        Document doc;
        if (parent instanceof Document) {
            doc = (Document)parent;
        } else {
            doc = parent.getOwnerDocument();
        }
        Element element = doc.createElement("image-config");
        int size;
        if (fitsOrder != null) {
            URelaxer.setElementPropertyByString(element, "fits-order", fitsOrder);
        }
        parent.appendChild(element);
    }

    /**
     * Gets the String property <b>fitsOrder</b>.
     *
     * @return String
     */
    public final String getFitsOrder() {
        return (fitsOrder);
    }

    /**
     * Sets the String property <b>fitsOrder</b>.
     *
     * @param fitsOrder
     */
    public final void setFitsOrder(String fitsOrder) {
        this.fitsOrder = fitsOrder;
    }

    /**
     * Gets the IRNode property <b>parentRNode</b>.
     *
     * @return IRNode
     */
    public final IRNode getParentRNode() {
        return (parentRNode);
    }

    /**
     * Sets the IRNode property <b>parentRNode</b>.
     *
     * @param parentRNode
     */
    public final void setParentRNode(IRNode parentRNode) {
        this.parentRNode = parentRNode;
    }

    /**
     * Gets child RNodes.
     *
     * @return IRNode[]
     */
    public IRNode[] getRNodes() {
        java.util.List classNodes = new java.util.ArrayList();
        IRNode[] nodes = new IRNode[classNodes.size()];
        return ((IRNode[])classNodes.toArray(nodes));
    }

    /**
     * Gets the RContext property <b>rContext</b>.
     *
     * @return RContext
     */
    public final RContext getRContext() {
        return (rContext);
    }

    /**
     * Sets the RContext property <b>rContext</b>.
     *
     * @param rContext
     */
    public final void setRContext(RContext rContext) {
        this.rContext = rContext;
        IRNode[] contextRNodes = getRNodes();
        for (int i = 0;i < contextRNodes.length;i++) {
            contextRNodes[i].setRContext(rContext);
        }
    }

    /**
     * Gets the property "rContext" which is resolved recursively.
     *
     * @return RContext
     */
    public RContext getRContextResolved() {
        if (rContext != null) {
            return (rContext);
        }
        if (parentRNode == null) {
            return (null);
        }
        return (parentRNode.getRContextResolved());
    }

    /**
     * Tests if a Element <code>element</code> is valid
     * for the <code>XmlImageConfig</code>.
     *
     * @param element
     * @return boolean
     */
    public static boolean isMatch(Element element) {
        String tagName = element.getTagName();
        if (!"image-config".equals(tagName)) {
            return (false);
        }
        RStack target = new RStack(element);
        Element child;
        child = target.peekElement();
        if (child != null) {
            if ("fits-order".equals(child.getTagName())) {
                target.popElement();
            }
        }
        if (!target.isEmptyElement()) {
            return (false);
        }
        return (true);
    }

    /**
     * Tests if elements contained in a Stack <code>stack</code>
     * is valid for the <code>XmlImageConfig</code>.
     * This mehtod is supposed to be used internally
     * by the Relaxer system.
     *
     * @param stack
     * @return boolean
     */
    public static boolean isMatch(RStack stack) {
        Element element = stack.peekElement();
        if (element == null) {
            return (false);
        }
        return (isMatch(element));
    }

    /**
     * Tests if elements contained in a Stack <code>stack</code>
     * is valid for the <code>XmlImageConfig</code>.
     * This method consumes the stack contents during matching operation.
     * This mehtod is supposed to be used internally
     * by the Relaxer system.
     *
     * @param stack
     * @return boolean
     */
    public static boolean isMatchHungry(RStack stack) {
        Element element = stack.peekElement();
        if (element == null) {
            return (false);
        }
        if (isMatch(element)) {
            stack.popElement();
            return (true);
        } else {
            return (false);
        }
    }
}
