package net.aerith.misao.xml.relaxer;

import org.w3c.dom.*;

/**
 * <b>XmlInformationHolder</b> is generated by Relaxer based on pixy.rlx.
 * This class is derived from:
 * 
 * <!-- for programmer
 * <elementRule role="information-holder">
 *   <ref label="information" occurs="*"/>
 * </elementRule>
 * 
 * <tag name="information-holder"/>
 * -->
 * <!-- for javadoc -->
 * <pre> &lt;elementRule role="information-holder"&gt;
 *   &lt;ref label="information" occurs="*"/&gt;
 * &lt;/elementRule&gt;
 * &lt;tag name="information-holder"/&gt;
 * </pre>
 *
 * @version pixy.rlx (Tue Nov 23 20:34:01 JST 2004)
 * @author  Relaxer 0.10.1 (by ASAMI@Yokohama)
 */
public class XmlInformationHolder extends net.aerith.misao.xml.IONode implements java.io.Serializable, IRNode {
    // List<XmlInformation>
    private java.util.List information = new java.util.ArrayList();
    private IRNode parentRNode;
    private RContext rContext;

    /**
     * Creates a <code>XmlInformationHolder</code>.
     *
     */
    public XmlInformationHolder() {
    }

    /**
     * Creates a <code>XmlInformationHolder</code> by the Stack <code>stack</code>
     * that contains Elements.
     * This constructor is supposed to be used internally
     * by the Relaxer system.
     *
     * @param stack
     */
    public XmlInformationHolder(RStack stack) {
        setup(stack);
    }

    /**
     * Creates a <code>XmlInformationHolder</code> by the Document <code>doc</code>.
     *
     * @param doc
     */
    public XmlInformationHolder(Document doc) {
        setup(doc.getDocumentElement());
    }

    /**
     * Creates a <code>XmlInformationHolder</code> by the Element <code>element</code>.
     *
     * @param element
     */
    public XmlInformationHolder(Element element) {
        setup(element);
    }

    /**
     * Initializes the <code>XmlInformationHolder</code> by the Document <code>doc</code>.
     *
     * @param doc
     */
    public void setup(Document doc) {
        setup(doc.getDocumentElement());
    }

    /**
     * Initializes the <code>XmlInformationHolder</code> by the Element <code>element</code>.
     *
     * @param element
     */
    public void setup(Element element) {
        init(element);
    }

    /**
     * Initializes the <code>XmlInformationHolder</code> by the Stack <code>stack</code>
     * that contains Elements.
     * This constructor is supposed to be used internally
     * by the Relaxer system.
     *
     * @param stack
     */
    public void setup(RStack stack) {
        setup(stack.popElement());
    }

    /**
     * @param element
     */
    private void init(Element element) {
        IPixyFactory factory = PixyFactory.getFactory();
        RStack stack = new RStack(element);
        information.clear();
        while (!stack.isEmptyElement()) {
            if (XmlInformation.isMatch(stack)) {
                addInformation(factory.createXmlInformation(stack));
            } else {
                break;
            }
        }
    }

    /**
     * Creates a DOM representation of the object.
     * Result is appended to the Node <code>parent</code>.
     *
     * @param parent
     */
    public void makeElement(Node parent) {
        Document doc;
        if (parent instanceof Document) {
            doc = (Document)parent;
        } else {
            doc = parent.getOwnerDocument();
        }
        Element element = doc.createElement("information-holder");
        int size;
        size = information.size();
        for (int i = 0;i < size;i++) {
            XmlInformation value = (XmlInformation)this.information.get(i);
            value.makeElement(element);
        }
        parent.appendChild(element);
    }

    /**
     * Gets the XmlInformation property <b>information</b>.
     *
     * @return XmlInformation[]
     */
    public final XmlInformation[] getInformation() {
        IPixyFactory factory = PixyFactory.getFactory();
        XmlInformation[] array = factory.createArrayXmlInformation(information.size());
        return ((XmlInformation[])information.toArray(array));
    }

    /**
     * Sets the XmlInformation property <b>information</b>.
     *
     * @param information
     */
    public final void setInformation(XmlInformation[] information) {
        this.information.clear();
        this.information.addAll(java.util.Arrays.asList(information));
        for (int i = 0;i < information.length;i++) {
            information[i].setParentRNode(this);
        }
    }

    /**
     * Adds the XmlInformation property <b>information</b>.
     *
     * @param information
     */
    public final void addInformation(XmlInformation information) {
        this.information.add(information);
        information.setParentRNode(this);
    }

    /**
     * Gets the IRNode property <b>parentRNode</b>.
     *
     * @return IRNode
     */
    public final IRNode getParentRNode() {
        return (parentRNode);
    }

    /**
     * Sets the IRNode property <b>parentRNode</b>.
     *
     * @param parentRNode
     */
    public final void setParentRNode(IRNode parentRNode) {
        this.parentRNode = parentRNode;
    }

    /**
     * Gets child RNodes.
     *
     * @return IRNode[]
     */
    public IRNode[] getRNodes() {
        java.util.List classNodes = new java.util.ArrayList();
        classNodes.addAll(information);
        IRNode[] nodes = new IRNode[classNodes.size()];
        return ((IRNode[])classNodes.toArray(nodes));
    }

    /**
     * Gets the RContext property <b>rContext</b>.
     *
     * @return RContext
     */
    public final RContext getRContext() {
        return (rContext);
    }

    /**
     * Sets the RContext property <b>rContext</b>.
     *
     * @param rContext
     */
    public final void setRContext(RContext rContext) {
        this.rContext = rContext;
        IRNode[] contextRNodes = getRNodes();
        for (int i = 0;i < contextRNodes.length;i++) {
            contextRNodes[i].setRContext(rContext);
        }
    }

    /**
     * Gets the property "rContext" which is resolved recursively.
     *
     * @return RContext
     */
    public RContext getRContextResolved() {
        if (rContext != null) {
            return (rContext);
        }
        if (parentRNode == null) {
            return (null);
        }
        return (parentRNode.getRContextResolved());
    }

    /**
     * Tests if a Element <code>element</code> is valid
     * for the <code>XmlInformationHolder</code>.
     *
     * @param element
     * @return boolean
     */
    public static boolean isMatch(Element element) {
        String tagName = element.getTagName();
        if (!"information-holder".equals(tagName)) {
            return (false);
        }
        RStack target = new RStack(element);
        Element child;
        while (!target.isEmptyElement()) {
            if (!XmlInformation.isMatchHungry(target)) {
                break;
            }
        }
        if (!target.isEmptyElement()) {
            return (false);
        }
        return (true);
    }

    /**
     * Tests if elements contained in a Stack <code>stack</code>
     * is valid for the <code>XmlInformationHolder</code>.
     * This mehtod is supposed to be used internally
     * by the Relaxer system.
     *
     * @param stack
     * @return boolean
     */
    public static boolean isMatch(RStack stack) {
        Element element = stack.peekElement();
        if (element == null) {
            return (false);
        }
        return (isMatch(element));
    }

    /**
     * Tests if elements contained in a Stack <code>stack</code>
     * is valid for the <code>XmlInformationHolder</code>.
     * This method consumes the stack contents during matching operation.
     * This mehtod is supposed to be used internally
     * by the Relaxer system.
     *
     * @param stack
     * @return boolean
     */
    public static boolean isMatchHungry(RStack stack) {
        Element element = stack.peekElement();
        if (element == null) {
            return (false);
        }
        if (isMatch(element)) {
            stack.popElement();
            return (true);
        } else {
            return (false);
        }
    }
}
