package net.aerith.misao.xml.relaxer;

import org.w3c.dom.*;

/**
 * <b>XmlPositionRecordHolder</b> is generated by Relaxer based on pixy.rlx.
 * This class is derived from:
 * 
 * <!-- for programmer
 * <elementRule role="position-record-holder">
 *   <ref label="position-record" occurs="*"/>
 * </elementRule>
 * 
 * <tag name="position-record-holder"/>
 * -->
 * <!-- for javadoc -->
 * <pre> &lt;elementRule role="position-record-holder"&gt;
 *   &lt;ref label="position-record" occurs="*"/&gt;
 * &lt;/elementRule&gt;
 * &lt;tag name="position-record-holder"/&gt;
 * </pre>
 *
 * @version pixy.rlx (Tue Nov 23 20:34:01 JST 2004)
 * @author  Relaxer 0.10.1 (by ASAMI@Yokohama)
 */
public class XmlPositionRecordHolder extends net.aerith.misao.xml.IONode implements java.io.Serializable, IRNode {
    // List<XmlPositionRecord>
    private java.util.List positionRecord = new java.util.ArrayList();
    private IRNode parentRNode;
    private RContext rContext;

    /**
     * Creates a <code>XmlPositionRecordHolder</code>.
     *
     */
    public XmlPositionRecordHolder() {
    }

    /**
     * Creates a <code>XmlPositionRecordHolder</code> by the Stack <code>stack</code>
     * that contains Elements.
     * This constructor is supposed to be used internally
     * by the Relaxer system.
     *
     * @param stack
     */
    public XmlPositionRecordHolder(RStack stack) {
        setup(stack);
    }

    /**
     * Creates a <code>XmlPositionRecordHolder</code> by the Document <code>doc</code>.
     *
     * @param doc
     */
    public XmlPositionRecordHolder(Document doc) {
        setup(doc.getDocumentElement());
    }

    /**
     * Creates a <code>XmlPositionRecordHolder</code> by the Element <code>element</code>.
     *
     * @param element
     */
    public XmlPositionRecordHolder(Element element) {
        setup(element);
    }

    /**
     * Initializes the <code>XmlPositionRecordHolder</code> by the Document <code>doc</code>.
     *
     * @param doc
     */
    public void setup(Document doc) {
        setup(doc.getDocumentElement());
    }

    /**
     * Initializes the <code>XmlPositionRecordHolder</code> by the Element <code>element</code>.
     *
     * @param element
     */
    public void setup(Element element) {
        init(element);
    }

    /**
     * Initializes the <code>XmlPositionRecordHolder</code> by the Stack <code>stack</code>
     * that contains Elements.
     * This constructor is supposed to be used internally
     * by the Relaxer system.
     *
     * @param stack
     */
    public void setup(RStack stack) {
        setup(stack.popElement());
    }

    /**
     * @param element
     */
    private void init(Element element) {
        IPixyFactory factory = PixyFactory.getFactory();
        RStack stack = new RStack(element);
        positionRecord.clear();
        while (!stack.isEmptyElement()) {
            if (XmlPositionRecord.isMatch(stack)) {
                addPositionRecord(factory.createXmlPositionRecord(stack));
            } else {
                break;
            }
        }
    }

    /**
     * Creates a DOM representation of the object.
     * Result is appended to the Node <code>parent</code>.
     *
     * @param parent
     */
    public void makeElement(Node parent) {
        Document doc;
        if (parent instanceof Document) {
            doc = (Document)parent;
        } else {
            doc = parent.getOwnerDocument();
        }
        Element element = doc.createElement("position-record-holder");
        int size;
        size = positionRecord.size();
        for (int i = 0;i < size;i++) {
            XmlPositionRecord value = (XmlPositionRecord)this.positionRecord.get(i);
            value.makeElement(element);
        }
        parent.appendChild(element);
    }

    /**
     * Gets the XmlPositionRecord property <b>positionRecord</b>.
     *
     * @return XmlPositionRecord[]
     */
    public final XmlPositionRecord[] getPositionRecord() {
        IPixyFactory factory = PixyFactory.getFactory();
        XmlPositionRecord[] array = factory.createArrayXmlPositionRecord(positionRecord.size());
        return ((XmlPositionRecord[])positionRecord.toArray(array));
    }

    /**
     * Sets the XmlPositionRecord property <b>positionRecord</b>.
     *
     * @param positionRecord
     */
    public final void setPositionRecord(XmlPositionRecord[] positionRecord) {
        this.positionRecord.clear();
        this.positionRecord.addAll(java.util.Arrays.asList(positionRecord));
        for (int i = 0;i < positionRecord.length;i++) {
            positionRecord[i].setParentRNode(this);
        }
    }

    /**
     * Adds the XmlPositionRecord property <b>positionRecord</b>.
     *
     * @param positionRecord
     */
    public final void addPositionRecord(XmlPositionRecord positionRecord) {
        this.positionRecord.add(positionRecord);
        positionRecord.setParentRNode(this);
    }

    /**
     * Gets the IRNode property <b>parentRNode</b>.
     *
     * @return IRNode
     */
    public final IRNode getParentRNode() {
        return (parentRNode);
    }

    /**
     * Sets the IRNode property <b>parentRNode</b>.
     *
     * @param parentRNode
     */
    public final void setParentRNode(IRNode parentRNode) {
        this.parentRNode = parentRNode;
    }

    /**
     * Gets child RNodes.
     *
     * @return IRNode[]
     */
    public IRNode[] getRNodes() {
        java.util.List classNodes = new java.util.ArrayList();
        classNodes.addAll(positionRecord);
        IRNode[] nodes = new IRNode[classNodes.size()];
        return ((IRNode[])classNodes.toArray(nodes));
    }

    /**
     * Gets the RContext property <b>rContext</b>.
     *
     * @return RContext
     */
    public final RContext getRContext() {
        return (rContext);
    }

    /**
     * Sets the RContext property <b>rContext</b>.
     *
     * @param rContext
     */
    public final void setRContext(RContext rContext) {
        this.rContext = rContext;
        IRNode[] contextRNodes = getRNodes();
        for (int i = 0;i < contextRNodes.length;i++) {
            contextRNodes[i].setRContext(rContext);
        }
    }

    /**
     * Gets the property "rContext" which is resolved recursively.
     *
     * @return RContext
     */
    public RContext getRContextResolved() {
        if (rContext != null) {
            return (rContext);
        }
        if (parentRNode == null) {
            return (null);
        }
        return (parentRNode.getRContextResolved());
    }

    /**
     * Tests if a Element <code>element</code> is valid
     * for the <code>XmlPositionRecordHolder</code>.
     *
     * @param element
     * @return boolean
     */
    public static boolean isMatch(Element element) {
        String tagName = element.getTagName();
        if (!"position-record-holder".equals(tagName)) {
            return (false);
        }
        RStack target = new RStack(element);
        Element child;
        while (!target.isEmptyElement()) {
            if (!XmlPositionRecord.isMatchHungry(target)) {
                break;
            }
        }
        if (!target.isEmptyElement()) {
            return (false);
        }
        return (true);
    }

    /**
     * Tests if elements contained in a Stack <code>stack</code>
     * is valid for the <code>XmlPositionRecordHolder</code>.
     * This mehtod is supposed to be used internally
     * by the Relaxer system.
     *
     * @param stack
     * @return boolean
     */
    public static boolean isMatch(RStack stack) {
        Element element = stack.peekElement();
        if (element == null) {
            return (false);
        }
        return (isMatch(element));
    }

    /**
     * Tests if elements contained in a Stack <code>stack</code>
     * is valid for the <code>XmlPositionRecordHolder</code>.
     * This method consumes the stack contents during matching operation.
     * This mehtod is supposed to be used internally
     * by the Relaxer system.
     *
     * @param stack
     * @return boolean
     */
    public static boolean isMatchHungry(RStack stack) {
        Element element = stack.peekElement();
        if (element == null) {
            return (false);
        }
        if (isMatch(element)) {
            stack.popElement();
            return (true);
        } else {
            return (false);
        }
    }
}
