package net.aerith.misao.xml.relaxer;

import org.w3c.dom.*;

/**
 * <b>XmlSize</b> is generated by Relaxer based on pixy.rlx.
 * This class is derived from:
 * 
 * <!-- for programmer
 * <elementRule role="size">
 *   <sequence>
 *     <element name="width" type="int"/>
 *     <element name="height" type="int"/>
 *   </sequence>
 * </elementRule>
 * 
 * <tag name="size"/>
 * -->
 * <!-- for javadoc -->
 * <pre> &lt;elementRule role="size"&gt;
 *   &lt;sequence&gt;
 *     &lt;element name="width" type="int"/&gt;
 *     &lt;element name="height" type="int"/&gt;
 *   &lt;/sequence&gt;
 * &lt;/elementRule&gt;
 * &lt;tag name="size"/&gt;
 * </pre>
 *
 * @version pixy.rlx (Tue Nov 23 20:34:01 JST 2004)
 * @author  Relaxer 0.10.1 (by ASAMI@Yokohama)
 */
public class XmlSize extends net.aerith.misao.xml.IONode implements java.io.Serializable, IRNode {
    private int width;
    private int height;
    private IRNode parentRNode;
    private RContext rContext;

    /**
     * Creates a <code>XmlSize</code>.
     *
     */
    public XmlSize() {
    }

    /**
     * Creates a <code>XmlSize</code> by the Stack <code>stack</code>
     * that contains Elements.
     * This constructor is supposed to be used internally
     * by the Relaxer system.
     *
     * @param stack
     */
    public XmlSize(RStack stack) {
        setup(stack);
    }

    /**
     * Creates a <code>XmlSize</code> by the Document <code>doc</code>.
     *
     * @param doc
     */
    public XmlSize(Document doc) {
        setup(doc.getDocumentElement());
    }

    /**
     * Creates a <code>XmlSize</code> by the Element <code>element</code>.
     *
     * @param element
     */
    public XmlSize(Element element) {
        setup(element);
    }

    /**
     * Initializes the <code>XmlSize</code> by the Document <code>doc</code>.
     *
     * @param doc
     */
    public void setup(Document doc) {
        setup(doc.getDocumentElement());
    }

    /**
     * Initializes the <code>XmlSize</code> by the Element <code>element</code>.
     *
     * @param element
     */
    public void setup(Element element) {
        init(element);
    }

    /**
     * Initializes the <code>XmlSize</code> by the Stack <code>stack</code>
     * that contains Elements.
     * This constructor is supposed to be used internally
     * by the Relaxer system.
     *
     * @param stack
     */
    public void setup(RStack stack) {
        setup(stack.popElement());
    }

    /**
     * @param element
     */
    private void init(Element element) {
        IPixyFactory factory = PixyFactory.getFactory();
        RStack stack = new RStack(element);
        width = URelaxer.getElementPropertyAsInt(stack.popElement());
        height = URelaxer.getElementPropertyAsInt(stack.popElement());
    }

    /**
     * Creates a DOM representation of the object.
     * Result is appended to the Node <code>parent</code>.
     *
     * @param parent
     */
    public void makeElement(Node parent) {
        Document doc;
        if (parent instanceof Document) {
            doc = (Document)parent;
        } else {
            doc = parent.getOwnerDocument();
        }
        Element element = doc.createElement("size");
        int size;
        URelaxer.setElementPropertyByInt(element, "width", width);
        URelaxer.setElementPropertyByInt(element, "height", height);
        parent.appendChild(element);
    }

    /**
     * Gets the int property <b>width</b>.
     *
     * @return int
     */
    public final int getWidth() {
        return (width);
    }

    /**
     * Sets the int property <b>width</b>.
     *
     * @param width
     */
    public final void setWidth(int width) {
        this.width = width;
    }

    /**
     * Gets the int property <b>height</b>.
     *
     * @return int
     */
    public final int getHeight() {
        return (height);
    }

    /**
     * Sets the int property <b>height</b>.
     *
     * @param height
     */
    public final void setHeight(int height) {
        this.height = height;
    }

    /**
     * Gets the IRNode property <b>parentRNode</b>.
     *
     * @return IRNode
     */
    public final IRNode getParentRNode() {
        return (parentRNode);
    }

    /**
     * Sets the IRNode property <b>parentRNode</b>.
     *
     * @param parentRNode
     */
    public final void setParentRNode(IRNode parentRNode) {
        this.parentRNode = parentRNode;
    }

    /**
     * Gets child RNodes.
     *
     * @return IRNode[]
     */
    public IRNode[] getRNodes() {
        java.util.List classNodes = new java.util.ArrayList();
        IRNode[] nodes = new IRNode[classNodes.size()];
        return ((IRNode[])classNodes.toArray(nodes));
    }

    /**
     * Gets the RContext property <b>rContext</b>.
     *
     * @return RContext
     */
    public final RContext getRContext() {
        return (rContext);
    }

    /**
     * Sets the RContext property <b>rContext</b>.
     *
     * @param rContext
     */
    public final void setRContext(RContext rContext) {
        this.rContext = rContext;
        IRNode[] contextRNodes = getRNodes();
        for (int i = 0;i < contextRNodes.length;i++) {
            contextRNodes[i].setRContext(rContext);
        }
    }

    /**
     * Gets the property "rContext" which is resolved recursively.
     *
     * @return RContext
     */
    public RContext getRContextResolved() {
        if (rContext != null) {
            return (rContext);
        }
        if (parentRNode == null) {
            return (null);
        }
        return (parentRNode.getRContextResolved());
    }

    /**
     * Tests if a Element <code>element</code> is valid
     * for the <code>XmlSize</code>.
     *
     * @param element
     * @return boolean
     */
    public static boolean isMatch(Element element) {
        String tagName = element.getTagName();
        if (!"size".equals(tagName)) {
            return (false);
        }
        RStack target = new RStack(element);
        Element child;
        child = target.popElement();
        if (child == null) {
            return (false);
        }
        if (!"width".equals(child.getTagName())) {
            return (false);
        }
        child = target.popElement();
        if (child == null) {
            return (false);
        }
        if (!"height".equals(child.getTagName())) {
            return (false);
        }
        if (!target.isEmptyElement()) {
            return (false);
        }
        return (true);
    }

    /**
     * Tests if elements contained in a Stack <code>stack</code>
     * is valid for the <code>XmlSize</code>.
     * This mehtod is supposed to be used internally
     * by the Relaxer system.
     *
     * @param stack
     * @return boolean
     */
    public static boolean isMatch(RStack stack) {
        Element element = stack.peekElement();
        if (element == null) {
            return (false);
        }
        return (isMatch(element));
    }

    /**
     * Tests if elements contained in a Stack <code>stack</code>
     * is valid for the <code>XmlSize</code>.
     * This method consumes the stack contents during matching operation.
     * This mehtod is supposed to be used internally
     * by the Relaxer system.
     *
     * @param stack
     * @return boolean
     */
    public static boolean isMatchHungry(RStack stack) {
        Element element = stack.peekElement();
        if (element == null) {
            return (false);
        }
        if (isMatch(element)) {
            stack.popElement();
            return (true);
        } else {
            return (false);
        }
    }
}
