package net.aerith.misao.xml.relaxer;

import org.w3c.dom.*;

/**
 * <b>XmlSystem</b> is generated by Relaxer based on pixy.rlx.
 * This class is derived from:
 * 
 * <!-- for programmer
 * <elementRule role="system">
 *   <sequence>
 *     <element name="version" type="string"/>
 *     <ref label="examined-date"/>
 *     <ref label="modified-date"/>
 *   </sequence>
 * </elementRule>
 * 
 * <tag name="system"/>
 * -->
 * <!-- for javadoc -->
 * <pre> &lt;elementRule role="system"&gt;
 *   &lt;sequence&gt;
 *     &lt;element name="version" type="string"/&gt;
 *     &lt;ref label="examined-date"/&gt;
 *     &lt;ref label="modified-date"/&gt;
 *   &lt;/sequence&gt;
 * &lt;/elementRule&gt;
 * &lt;tag name="system"/&gt;
 * </pre>
 *
 * @version pixy.rlx (Tue Nov 23 20:34:01 JST 2004)
 * @author  Relaxer 0.10.1 (by ASAMI@Yokohama)
 */
public class XmlSystem extends net.aerith.misao.xml.IONode implements java.io.Serializable, IRNode {
    private String version;
    private String examinedDate;
    private String modifiedDate;
    private IRNode parentRNode;
    private RContext rContext;

    /**
     * Creates a <code>XmlSystem</code>.
     *
     */
    public XmlSystem() {
    }

    /**
     * Creates a <code>XmlSystem</code> by the Stack <code>stack</code>
     * that contains Elements.
     * This constructor is supposed to be used internally
     * by the Relaxer system.
     *
     * @param stack
     */
    public XmlSystem(RStack stack) {
        setup(stack);
    }

    /**
     * Creates a <code>XmlSystem</code> by the Document <code>doc</code>.
     *
     * @param doc
     */
    public XmlSystem(Document doc) {
        setup(doc.getDocumentElement());
    }

    /**
     * Creates a <code>XmlSystem</code> by the Element <code>element</code>.
     *
     * @param element
     */
    public XmlSystem(Element element) {
        setup(element);
    }

    /**
     * Initializes the <code>XmlSystem</code> by the Document <code>doc</code>.
     *
     * @param doc
     */
    public void setup(Document doc) {
        setup(doc.getDocumentElement());
    }

    /**
     * Initializes the <code>XmlSystem</code> by the Element <code>element</code>.
     *
     * @param element
     */
    public void setup(Element element) {
        init(element);
    }

    /**
     * Initializes the <code>XmlSystem</code> by the Stack <code>stack</code>
     * that contains Elements.
     * This constructor is supposed to be used internally
     * by the Relaxer system.
     *
     * @param stack
     */
    public void setup(RStack stack) {
        setup(stack.popElement());
    }

    /**
     * @param element
     */
    private void init(Element element) {
        IPixyFactory factory = PixyFactory.getFactory();
        RStack stack = new RStack(element);
        version = URelaxer.getElementPropertyAsString(stack.popElement());
        examinedDate = URelaxer.getElementPropertyAsString(stack.popElement());
        modifiedDate = URelaxer.getElementPropertyAsString(stack.popElement());
    }

    /**
     * Creates a DOM representation of the object.
     * Result is appended to the Node <code>parent</code>.
     *
     * @param parent
     */
    public void makeElement(Node parent) {
        Document doc;
        if (parent instanceof Document) {
            doc = (Document)parent;
        } else {
            doc = parent.getOwnerDocument();
        }
        Element element = doc.createElement("system");
        int size;
        URelaxer.setElementPropertyByString(element, "version", version);
        URelaxer.setElementPropertyByString(element, "examined-date", examinedDate);
        URelaxer.setElementPropertyByString(element, "modified-date", modifiedDate);
        parent.appendChild(element);
    }

    /**
     * Gets the String property <b>version</b>.
     *
     * @return String
     */
    public final String getVersion() {
        return (version);
    }

    /**
     * Sets the String property <b>version</b>.
     *
     * @param version
     */
    public final void setVersion(String version) {
        this.version = version;
    }

    /**
     * Gets the String property <b>examinedDate</b>.
     *
     * @return String
     */
    public final String getExaminedDate() {
        return (examinedDate);
    }

    /**
     * Sets the String property <b>examinedDate</b>.
     *
     * @param examinedDate
     */
    public final void setExaminedDate(String examinedDate) {
        this.examinedDate = examinedDate;
    }

    /**
     * Gets the String property <b>modifiedDate</b>.
     *
     * @return String
     */
    public final String getModifiedDate() {
        return (modifiedDate);
    }

    /**
     * Sets the String property <b>modifiedDate</b>.
     *
     * @param modifiedDate
     */
    public final void setModifiedDate(String modifiedDate) {
        this.modifiedDate = modifiedDate;
    }

    /**
     * Gets the IRNode property <b>parentRNode</b>.
     *
     * @return IRNode
     */
    public final IRNode getParentRNode() {
        return (parentRNode);
    }

    /**
     * Sets the IRNode property <b>parentRNode</b>.
     *
     * @param parentRNode
     */
    public final void setParentRNode(IRNode parentRNode) {
        this.parentRNode = parentRNode;
    }

    /**
     * Gets child RNodes.
     *
     * @return IRNode[]
     */
    public IRNode[] getRNodes() {
        java.util.List classNodes = new java.util.ArrayList();
        IRNode[] nodes = new IRNode[classNodes.size()];
        return ((IRNode[])classNodes.toArray(nodes));
    }

    /**
     * Gets the RContext property <b>rContext</b>.
     *
     * @return RContext
     */
    public final RContext getRContext() {
        return (rContext);
    }

    /**
     * Sets the RContext property <b>rContext</b>.
     *
     * @param rContext
     */
    public final void setRContext(RContext rContext) {
        this.rContext = rContext;
        IRNode[] contextRNodes = getRNodes();
        for (int i = 0;i < contextRNodes.length;i++) {
            contextRNodes[i].setRContext(rContext);
        }
    }

    /**
     * Gets the property "rContext" which is resolved recursively.
     *
     * @return RContext
     */
    public RContext getRContextResolved() {
        if (rContext != null) {
            return (rContext);
        }
        if (parentRNode == null) {
            return (null);
        }
        return (parentRNode.getRContextResolved());
    }

    /**
     * Tests if a Element <code>element</code> is valid
     * for the <code>XmlSystem</code>.
     *
     * @param element
     * @return boolean
     */
    public static boolean isMatch(Element element) {
        String tagName = element.getTagName();
        if (!"system".equals(tagName)) {
            return (false);
        }
        RStack target = new RStack(element);
        Element child;
        child = target.popElement();
        if (child == null) {
            return (false);
        }
        if (!"version".equals(child.getTagName())) {
            return (false);
        }
        child = target.popElement();
        if (child == null) {
            return (false);
        }
        if (!"examined-date".equals(child.getTagName())) {
            return (false);
        }
        child = target.popElement();
        if (child == null) {
            return (false);
        }
        if (!"modified-date".equals(child.getTagName())) {
            return (false);
        }
        if (!target.isEmptyElement()) {
            return (false);
        }
        return (true);
    }

    /**
     * Tests if elements contained in a Stack <code>stack</code>
     * is valid for the <code>XmlSystem</code>.
     * This mehtod is supposed to be used internally
     * by the Relaxer system.
     *
     * @param stack
     * @return boolean
     */
    public static boolean isMatch(RStack stack) {
        Element element = stack.peekElement();
        if (element == null) {
            return (false);
        }
        return (isMatch(element));
    }

    /**
     * Tests if elements contained in a Stack <code>stack</code>
     * is valid for the <code>XmlSystem</code>.
     * This method consumes the stack contents during matching operation.
     * This mehtod is supposed to be used internally
     * by the Relaxer system.
     *
     * @param stack
     * @return boolean
     */
    public static boolean isMatchHungry(RStack stack) {
        Element element = stack.peekElement();
        if (element == null) {
            return (false);
        }
        if (isMatch(element)) {
            stack.popElement();
            return (true);
        } else {
            return (false);
        }
    }
}
